--
-- Holy Power Notifier - Tells you when you've got Holy Power.
-- Gilbert - Tichondrius US
--

-- Stop now if the player isn't a Paladin.
if select(2, UnitClass('player')) ~= "PALADIN" then
    DisableAddOn("HolyPowerNotifier")
    return
end

-- Set up our frame
local frame, events = CreateFrame("Frame"), {}
local texture = frame:CreateTexture()
frame:SetPoint("CENTER",0,80)
frame:SetWidth(128)
frame:SetHeight(128)
texture:SetAllPoints(frame)
texture:SetTexture("Interface\\Addons\\HolyPowerNotifier\\holypower.tga")
frame:Hide()

-- Our command line option
function HolyPowerNotifier(input)
    local value = tonumber(input)

    if not value or value < 1 or value > 3 then
	print ("|cffffff00Usage: /hpn 1-3")
	print ("|cffffff00Sets the number of Holy Power you must have for the frame to be visible.")
	print ("|cffffff00Current threshold: "..HolyPowerCount)
    else
	HolyPowerCount = value
	print ("|cffffff00Holy Power threshold set to "..value)
    end
end

-- Blizzard resets Holy Power to zero when zoning, but doesn't send
-- a UNIT_POWER event. We'll clear the frame on zoning.
function events:PLAYER_ENTERING_WORLD(...)
    frame:Hide();

    -- Check if our variable is set as well.
    if not HolyPowerCount then
	HolyPowerCount = 3
    end
end

-- Watch for UNIT_POWER events.
function events:UNIT_POWER(source,type)
    -- Make sure its our power, and that it's Holy Power
    if source == "player" and type == "HOLY_POWER" then
	local power = UnitPower("player",9)

	-- Check if it's at the threshold
	if power >= HolyPowerCount then
	    frame:Show()
	else
	    frame:Hide()
	end
    end
end

-- Register our events
frame:SetScript("OnEvent", function(self,event,...) events[event](self,...) end)

for k,v in pairs(events) do
    frame:RegisterEvent(k)
end

-- Register our slash commands
SLASH_HOLYPOWERNOTIFIER1 = '/hpn'
SlashCmdList["HOLYPOWERNOTIFIER"] = HolyPowerNotifier